#include <iostream>
#include <utility>
#include <map>
#include <unordered_map>

using Subject = std::string;
using Time    = std::string;
using Room    = std::string;

using Class_schedule = std::unordered_map<Subject, std::unordered_map<Time, Room>>;
using Room_schedule  = std::map<Room, std::map<Time, Subject>>;

Room_schedule to_room_schedule(const Class_schedule& class_schedule) {
    // TODO
}

int main() {
	const auto class_schedule = Class_schedule{
        {"C/C++", {
            {"Mo. 20:00", "3B"},
            {"Fr. 14:00", "L402"}
        }},
        {"Java", {
            {"Di. 06:15", "HS1"},
            {"Di. 08:00", "HS1"}
        }},
        {"The Mathematics of Quantum Neutrino Fields", {
            {"Mo. 17:30", "3B"}
        }}
    };

    const auto room_schedule = to_room_schedule(class_schedule);

    for(auto&&[room, timeslots] : room_schedule) {
        std::cout << room << ":\n";
        for(auto&&[time, subject] : timeslots) {
            std::cout << "\t" << time << " " << subject << "\n";
        }
    }
}

